NEWFS(8)

NAME
newfs, mount_mfs - construct a new file system

SYNOPSIS
newfs [-NO] [-S sector-size] [-T disktype] [-a maxcontig] [-b block-size] [-c cylinders] [-d rotdelay] [-e maxbpg] [-f frag-size] [-i bytes] [-k skew] [-l interleave] [-m free space] [-n rotational positions] [-o optimization] [-p sectors] [-r revolutions] [-s size] [-t tracks] [-u sectors] [-v] [-x sectors] special
mount_mfs [-N] [-F file] [-T disktype] [-a maxcontig] [-b block-size] [-c cylinders] [-d rotdelay] [-e maxbpg] [-f frag-size] [-i bytes] [-m free space] [-n rotational positions] [-o options] [-s size] special node

DESCRIPTION
Newfs replaces the more obtuse mkfs(8) program. Before running newfs or mount_mfs, the disk must be labeled using disklabel(8). Newfs builds a file system on the specified special file. (We often refer to the “special file” as the “disk”, although the special file need not be a physical disk. In fact, it need not even be special.) Typically the defaults are reasonable, however newfs has numerous options to allow the defaults to be selectively overridden.

Mount_mfs is used to build a file system in virtual memory and then mount it on a specified node. Mount_mfs exits and the contents of the file system are lost when the file system is unmounted. If mount_mfs is sent a signal while running, for example during system shutdown, it will attempt to unmount its corresponding file system. The parameters to mount_mfs are the same as those to newfs. If the -T flag is specified (see below), the special file is unused. Otherwise, it is only used to read the disk label which provides a set of configuration parameters for the memory based file system. The special file is typically that of the primary swap area, since that is where the file system will be backed up when free memory gets low and the memory supporting the file system has to be paged.

The following options define the general layout policies:

-T disktype
    For backward compatibility and for mount_mfs.

-F file
    Mount_mfs will use this file for the image of the filesystem. When mount_mfs exits, this file will be left behind.

-N  Cause the file system parameters to be printed out without really creating the file system.

-O  Create a 4.3BSD format filesystem. This options is primarily used to build root filesystems that can be understood by older boot ROMs.

-T  Use information for the specified disk from /etc/disktab instead of trying to get the information from a disklabel.

-a maxcontig
    Specify the maximum number of contiguous blocks that will be laid out before forcing a rotational delay (see the -d option). The default value is 1. See tunefs(8) for more details on how to set this option.

-b block-size
    The block size of the file system, in bytes. It must be a power of 2. The default size is 8192 bytes, and the smallest allowable size is 4096 bytes.

-c #cylinders/group
    The number of cylinders per cylinder group in a file system. The default value is 16. The maximum value is dependent on a number of other parameters, in particular the block size. The best way to find the maximum value for a specific file system is to attempt to specify a value which is far too large: newfs will print out the maximum value.

-d rotdelay
    This parameter once specified the minimum time in milliseconds required to initiate another disk transfer on the same cylinder. It was used in determining the rotationally optimal layout for disk blocks within a file. Modern disks with read/write-behind achieve higher performance with this feature disabled, so this value should be left at the default value of 0 milliseconds. See tunefs(8) for more details on how to set this option.

-e maxbpg
    Indicate the maximum number of blocks any single file can allocate out of a cylinder group before it is forced to begin allocating blocks from another cylinder group. The default is about one quarter of the total blocks in a cylinder group. See tunefs(8) for more details on how to set this option.

-f frag-size
    The fragment size of the file system in bytes. It must be a power of two ranging in value between blocksize/8 and blocksize. The default is 1024 bytes.

-i number of bytes per inode
    Specify the density of inodes in the file system. The default is to create an inode for every (4 * frag-size) bytes of data space. If fewer inodes are desired, a larger number should be used; to create more inodes a smaller number should be given. One inode is required for each distinct file, so this value effectively specifies the average file size on the file system.

-m free space %
    The percentage of space reserved from normal users; the minimum free space threshold. The default value used is defined by MINFREE from <ufs/ffs/fs.h>, currently 8%. See tunefs(8) for more details on how to set this option.

-n number of distinguished rotational positions
    UFS has the ability to keep track of the availability of blocks at different rotational positions, so that it could lay out the data to be picked up with minimum rotational latency. This parameter specifies the default number of rotational positions to distinguish.

    Nowadays this value should be set to 1 (which essentially disables the rotational position table) because modern drives with read-ahead and write-behind do better without the rotational position table.

-o optimization preference
    (``space'' or ``time'') The file system can either be instructed to try to minimize the time spent allocating blocks, or to try to minimize the space fragmentation on the disk. If the value of minfree (see above) is less than 8%, the default is to optimize for space; if the value of minfree is greater than or equal to 8%, the default is to optimize for time. See tunefs(8) for more details on how to set this option.

-s size
    The size of the file system in sectors. This value defaults to the size of the raw partition specified in special (in other words, newfs will use the entire partition for the file system).

-v  Specify that the disk does not contain any partitions, and that newfs should build a file system on the whole disk. This option is useful for synthetic disks such as vinum.

The following options override the standard sizes for the disk geometry. Their default values are taken from the disk label. Changing these defaults is useful only when using newfs to build a file system whose raw image will eventually be used on a different type of disk than the one on which it is initially created (for example on a write-once disk). Note that changing any of these values from their defaults will make it impossible for fsck(8) to find the alternate superblocks if the standard superblock is lost.

-S sector-size
    The size of a sector in bytes (almost never anything but 512).

-k sector 0 skew, per track
    Used to describe perturbations in the media format to compensate for a slow controller. Track skew is the offset of sector 0 on track N relative to sector 0 on track N-1 on the same cylinder. This option is of historical importance only; modern controllers are always fast enough to handle operations back-to-back.

-l hardware sector interleave
    Used to describe perturbations in the media format to compensate for a slow controller. Interleave is physical sector interleave on each track, specified as the denominator of the ratio:
        sectors read/sectors passed over
    Thus an interleave of 1/1 implies contiguous layout, while 1/2 implies logical sector 0 is separated by one sector from logical sector 1. This option is of historical importance only; the physical sector layout of modern disks is not visible from outside.

-p spare sectors per track
    Spare sectors (bad sector replacements) are physical sectors that occupy space at the end of each track. They are not counted as part of the sectors/track (-u) since they are not available to the file system for data allocation. This option is of historical importance only. Modern disks perform their own bad sector allocation.

-r revolutions/minute
    The speed of the disk in revolutions per minute. This value is no longer of interest, since all the parameters which depend on it are usually disabled.

-t #tracks/cylinder
    The number of tracks/cylinder available for data allocation by the file system. The default is 1. If zero is specified, the value from the disklabel will be used.

-u sectors/track
    The number of sectors per track available for data allocation by the file system. The default is 4096. If zero is specified, the value from the disklabel will be used. This does not include sectors reserved at the end of each track for bad block replacement (see the -p option).

-x spare sectors per cylinder
    Spare sectors (bad sector replacements) are physical sectors that occupy space at the end of the last track in the cylinder. They are deducted from the sectors/track (-u) of the last track of each cylinder since they are not available to the file system for data allocation. This option is of historical importance only. Modern disks perform their own bad sector allocation.

The options to the mount_mfs command are as described for the newfs command, except for the -o option.

That option is as follows:

-o  Options are specified with a -o flag followed by a comma separated string of options. See the mount(8) man page for possible options and their meanings.

EXAMPLES

    mount_mfs -s 131072 -o nosuid,nodev /dev/da0s1b /tmp

Mount a 64 MB large memory file system on /tmp, with mount(8) options nosuid and nodev.

BUGS
The boot code of FreeBSD assumes that the file system that carries the kernel has blocks of 8 kilobytes and fragments of 1 kilobyte. You will not be able to boot from a file system that uses another size.

SEE ALSO
fdformat(1), disktab(5), fs(5), camcontrol(8), disklabel(8), diskpart(8), dumpfs(8), fsck(8), mount(8), tunefs(8), vinum(8) M. McKusick, W. Joy, S. Leffler, R. Fabry, A Fast File System for UNIX ,, ACM Transactions on Computer Systems 2, 3, pp 181-197, August 1984, (reprinted in the BSD System Manager's Manual).

HISTORY
The newfs command appeared in 4.2BSD.